//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  SHGetKnownFolderIDList ֐gpētH_̍ڎʎq擾
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ܂Czz̍ہCȂ闝R낤Ƃɑ㉿߂邱Ƃ֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//
//  yz
//
//  2013N0705 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    Edit1: TEdit;
    OpenDialog1: TOpenDialog;
    RadioGroup1: TRadioGroup;
    Edit2: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure ListBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure RadioGroup1Click(Sender: TObject);
  private
    { Private 錾 }
    FStrList : TStringList;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses 
  ShlObj, 
  ActiveX, 
  ShellAPI;

//=============================================================================
//  Form ̏
//  fBXNt@Cǂݍ
//  ListBox1 ̊e Item ɕ\ FOLDERID ̕Zbg
//  ۂɎgp FOLDERID  TGUID ͕Ƃ TStringList Ɏc
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
var
  LTempStrList : TStringList;
  LIndex       : Integer;
begin
  FStrList     := TStringList.Create;
  LTempStrList := TStringList.Create;
  try
    FStrList.LoadFromFile('../FOLDERID_List.csv');
    FStrList.Sort;

    // CSV 𑀍삷̂Ńf~^ݒ
    LTempStrList.Delimiter       := ',';
    LTempStrList.StrictDelimiter := True;

    for LIndex := 0 to FStrList.Count - 1 do begin
      LTempStrList.DelimitedText := FStrList[LIndex];
      ListBox1.Items.Add(Trim(LTempStrList[0]));
      FStrList[LIndex] := Trim(LTempStrList[1]);
    end;
  finally
    FreeAndNil(LTempStrList);
  end;
end;

//=============================================================================
//  Ȉ
//=============================================================================
procedure TForm1.FormDestroy(Sender: TObject);
begin
  FreeAndNil(FStrList);
end;

//-----------------------------------------------------------------------------
//  ΍ڎʎqtH_܂̓t@C߂
//  ztH_ GUID Ƃċ܂
//
//   1   Ώۂ̍ڎʎq擾ۂɎgpVFtH_IuWFNg
//   2   Ώۂ̍ڎʎqDShFolder Kw̑Βl
//   3   tpX擾ꍇ́CSHGDN_FORPARSING
//             t@C擾ꍇ́CSHGDN_NORMAL ܂ SHGDN_INFOLDER
//-----------------------------------------------------------------------------
function GetDispNameFromPItemID(ShFolder: IShellFolder; ItemID:
  PItemIDList; Flag: DWORD=SHGDN_NORMAL): string;
var
  LStrRet : TStrRet;
begin
  Result := '';
  if ShFolder = nil then exit;
  if ItemID = nil then exit;

  FillChar(LStrRet, SizeOf(LStrRet), #0);
  if NOERROR = ShFolder.GetDisplayNameOf(ItemID, Flag, LStrRet) then begin
    Result := LStrRet.pOleStr;
  end;
end;

//=============================================================================
//  TListBox ̍ڂ_uNbN炻 FOLDERID ɑ鍀ڎʎq擾
//  ̍ڎʎqɑtH_
//  [t@CI] _CAO܂̓GNXv[J
//=============================================================================
procedure TForm1.ListBox1DblClick(Sender: TObject);
var
  LIndex          : Integer;
  LFolderID       : TGUID;
  LItemID         : PItemIDList;
  LpDesktopFolder : IShellFolder;
  LDisplayName    : string;
  LFolderPath     : string;
  LExeFile        : string;
  LhInst          : Cardinal;
begin
  Edit1.Text := '';
  Edit2.Text := '';
  LItemID    := nil;

  // FOLDERID  TGUID ̒l擾
  LIndex    := ListBox1.ItemIndex;
  LFolderID := StringToGUID(FStrList[LIndex]);

  // FOLDERID  TGUID ɑ鍀ڎʎq擾
  if SHGetKnownFolderIDList(LFolderID, 0, 0, LItemID) = S_OK then begin

    // [fXNgbv] ̃VFtH_IuWFNg擾
    SHGetDesktopFolder(LpDesktopFolder);

    // 擾ڎʎq\ƃoX擾
    LDisplayName := GetDispNameFromPItemID(LpDesktopFolder, LItemID, SHGDN_INFOLDER);
    LFolderPath  := GetDispNameFromPItemID(LpDesktopFolder, LItemID, SHGDN_FORPARSING);

    Edit1.Text := LFolderPath;
    Edit2.Text := LDisplayName;

    // ȉC擾l̊mFp
    if (Sender <> nil) and (LFolderPath <> '') then begin
      if RadioGroup1.ItemIndex = 0 then begin
        OpenDialog1.InitialDir := LFolderPath;
        OpenDialog1.Execute;
        Update;
      end else begin
        // ۂɂ͋NAvłGNXv[͋N
        // 邢́CNt@CɃpXw肷΋N
        LExeFile := 'explorer.exe';
        LhInst   := ShellExecute(Handle,
                                'open',
                                PChar(LExeFile),
                                PChar(LFolderPath),
                                nil,
                                SW_SHOW);
        if LhInst <= 32 then begin
          MessageBox(Handle, 'NɎs܂D', '', MB_ICONINFORMATION);
        end;
      end;
    end;
  end;

  // ڎʎq̃AP[g̉
  if LItemID <> nil then CoTaskMemFree(LItemID);
end;

//=============================================================================
//  ListBox1 ̍ڂICpX擾 Edit1 ɕ\
//=============================================================================
procedure TForm1.ListBox1Click(Sender: TObject);
begin
  ListBox1DblClick(nil);
end;

//=============================================================================
//  ListBox1  [Enter] L[C_uNbNƓ
//=============================================================================
procedure TForm1.ListBox1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_RETURN then begin
    ListBox1DblClick(Sender);
  end;
end;

//=============================================================================
//  RaditoGroup1  OnClick Cxg
//  ListBox1 ɃtH[JXړ [Enter] L[\ɂ
//=============================================================================
procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  ListBox1.SetFocus;
end;

end.
