//{$WARNINGS OFF}
//=============================================================================
//  SHGetKnownFolderIDList ֐gpētH_̍ڎʎq擾
//  ShellExecuteEx ֐ŁC̍ڎʎq̃tH_CGNXv[ŕ\
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ܂Czz̍ہCȂ闝R낤Ƃɑ㉿߂邱Ƃ֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//
//  yz
//
//  2013N0705 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    Edit1: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure ListBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private 錾 }
    FStrList : TStringList;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses 
  ShlObj, 
  ShellAPI, 
  ActiveX;

//=============================================================================
//  Form ̏
//  fBXNt@Cǂݍ
//  ListBox1 ̊e Item ɕ\ FOLDERID ̕Zbg
//  ۂɎgp FOLDERID  TGUID ͕Ƃ TStringList Ɏc
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
var
  LTempStrList : TStringList;
  LIndex       : Integer;
begin
  FStrList     := TStringList.Create;
  LTempStrList := TStringList.Create;
  try
    FStrList.LoadFromFile('../FOLDERID_List.csv');
    FStrList.Sort;

    // CSV 𑀍삷̂Ńf~^ݒ
    LTempStrList.Delimiter       := ',';
    LTempStrList.StrictDelimiter := True;

    for LIndex := 0 to FStrList.Count - 1 do begin
      LTempStrList.DelimitedText := FStrList[LIndex];
      ListBox1.Items.Add(Trim(LTempStrList[0]));
      FStrList[LIndex] := Trim(LTempStrList[1]);
    end;
  finally
    FreeAndNil(LTempStrList);
  end;
end;

//=============================================================================
//  Ȉ
//=============================================================================
procedure TForm1.FormDestroy(Sender: TObject);
begin
  FreeAndNil(FStrList);
end;

//-----------------------------------------------------------------------------
//  ShellExecuteEx Ŏwt@Cs
//
//  SEE_MASK_NOCLOSEPROCESS
//    ShellExcuteEx sCvZXێProcessɃvZX̃nhԂ
//  SEE_MASK_FLAG_NO_UI
//    G[ɃbZ[W Box \Ȃ
//  SEE_MASK_IDLIST
//    ڎʎqgp
//-----------------------------------------------------------------------------
function RunExeFilePIDL(hWnd: HWND; AFile: String; pidlFile: PItemIDList;
   Verb: string): Cardinal;
var
  LInfo : TShellExecuteInfo;
  LRet  : DWORD;
begin
  FillChar(LInfo, SizeOf(LInfo), 0);
  LInfo.cbSize := SizeOf(LInfo);
  LInfo.Wnd      := hWnd;
  LInfo.fMask    := SEE_MASK_NOCLOSEPROCESS or SEE_MASK_FLAG_NO_UI or SEE_MASK_IDLIST;
  LInfo.lpVerb   := PChar(Verb);
  LInfo.lpFile   := PChar(AFile);
  LInfo.lpIDList := pidlFile;
  LInfo.nShow    := SW_SHOW;

  ShellExecuteEx(@LInfo);

  // ShellExecuteEx ͐ hInstApp 33 ȏ̒lԂ
  if LInfo.hInstApp >= 33 then
  begin
    repeat
      LRet := WaitForInputIdle(LInfo.hProcess, 50);
      Application.ProcessMessages;
    until LRet <> WAIT_TIMEOUT;
  end;
  CloseHandle(LInfo.hProcess);

  Result := LInfo.hInstApp;
end;

//=============================================================================
//  TListBox ̍ڂ_uNbN炻 FOLDERID ɑ鍀ڎʎq擾
//  ̍ڎʎqɑtH_GNXv[ŊJ
//=============================================================================
procedure TForm1.ListBox1DblClick(Sender: TObject);
var
  LIndex    : Integer;
  LFolderID : TGUID;
  LItemID   : PItemIDList;
  LBuff     : array [0..MAX_PATH] of Char;
  LExeFile  : string;
  LiRet     : Cardinal;
begin
  Edit1.Text := '';
  LItemID     := nil;

  // LFolderID  TGUID ̒l擾
  LIndex    := ListBox1.ItemIndex;
  LFolderID := StringToGUID(FStrList[LIndex]);

  // LFolderID  TGUID ɑ鍀ڎʎq擾
  if SHGetKnownFolderIDList(LFolderID, 0, 0, LItemID) = S_OK then begin

    // ڎʎqpX擾
    // ztH_͎擾łȂ
    FillChar(LBuff, SizeOf(LBuff), #0);
    SHGetPathFromIDList(LItemID, LBuff);
    Edit1.Text := LBuff;

    // ȉC擾l̊mFp
    // ۂɂ͋NAvłGNXv[͋N
    // 邢́CNt@CɃpXw肷΋N
    LExeFile := 'explorer.exe';
    if Sender <> nil then begin
      if LItemID <> nil then begin
        LiRet := RunExeFilePIDL(0, LExeFile, LItemID, '');
        if LiRet <= 32 then begin
          MessageBox(Handle, 'NɎs܂D', '', MB_ICONINFORMATION);
        end;
      end;
    end;
  end;

  // ڎʎq̃AP[g̉
  if LItemID <> nil then CoTaskMemFree(LItemID);
end;

//=============================================================================
//  ListBox1 ̍ڂICpX擾 Edit1 ɕ\
//=============================================================================
procedure TForm1.ListBox1Click(Sender: TObject);
begin
  ListBox1DblClick(nil);
end;

//=============================================================================
//  ListBox1  [Enter] L[C_uNbNƓ
//=============================================================================
procedure TForm1.ListBox1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_RETURN then begin
    ListBox1DblClick(Sender);
  end;
end;

end.
