//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  SHGetKnownFolderItem ֐gpētH_ IShellItem IuWFNg擾
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//
//  yz
//
//  2013N0705 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    Edit1: TEdit;
    RadioGroup1: TRadioGroup;
    OpenDialog1: TOpenDialog;
    Edit2: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure ListBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure RadioGroup1Click(Sender: TObject);
  private
    { Private 錾 }
    FStrList : TStringList;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses 
  ShlObj, 
  ShellAPI, 
  ActiveX;

//=============================================================================
//  Form ̏
//  fBXNt@Cǂݍ
//  ListBox1 ̊e Item ɕ\ FOLDERID ̕Zbg
//  ۂɎgp FOLDERID  TGUID ͕Ƃ TStringList Ɏc
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
var
  LTempStrList : TStringList;
  LIndex       : Integer;
begin
  FStrList     := TStringList.Create;
  LTempStrList := TStringList.Create;
  try
    FStrList.LoadFromFile('../FOLDERID_List.csv');
    FStrList.Sort;

    // CSV 𑀍삷̂Ńf~^ݒ
    LTempStrList.Delimiter       := ',';
    LTempStrList.StrictDelimiter := True;

    for LIndex := 0 to FStrList.Count - 1 do begin
      LTempStrList.DelimitedText := FStrList[LIndex];
      ListBox1.Items.Add(Trim(LTempStrList[0]));
      FStrList[LIndex] := Trim(LTempStrList[1]);
    end;
  finally
    FreeAndNil(LTempStrList);
  end;
end;

//=============================================================================
//  Ȉ
//=============================================================================
procedure TForm1.FormDestroy(Sender: TObject);
begin
  FreeAndNil(FStrList);
end;

//=============================================================================
//  _uNbN FOLDERID ɑ IShellItem IuWFNg擾
//  IShellItem  GetDisplayName \bhŃtH_̃pXƕ\擾
//  ̃tH_ [t@CJ] _CAO܂͂GNXv[ŕ\
//=============================================================================
procedure TForm1.ListBox1DblClick(Sender: TObject);
var
  LIndex        : Integer;
  LFolderID     : TGUID;
  LpItem        : IShellItem;
  LiRet         : HRESULT;
  LpFilePath    : PChar;
  LpDisplayName : PChar;
  LExeFile      : string;
  LhInst        : Cardinal;
begin
  Edit1.Text    := '';
  Edit2.Text    := '';
  LpFilePath    := nil;
  LpDisplayName := nil;

  // ListBox1  Index 擾Ă TObject Œ`lo
  LIndex    := ListBox1.ItemIndex;
  LFolderID := StringToGUID(FStrList[LIndex]);

  // FOLDERID ɑ IShellItem IuWFNg擾
  LiRet := SHGetKnownFolderItem(LFolderID, 0, 0, IID_IShellItem, Pointer(LpItem));

  if LiRet = S_OK then begin
    //GetDisplayName\bhŃpXƕ\擾
    // SIGDN_FILESYSPATH ɂƉztH_ GUID ͎擾łȂ
    LpItem.GetDisplayName(SIGDN_DESKTOPABSOLUTEPARSING, LpFilePath);
    LpItem.GetDisplayName(SIGDN_NORMALDISPLAY,          LpDisplayName);

    Edit1.Text := LpFilePath;
    Edit2.Text := LpDisplayName;

    // ȉC擾l̊mFp
    if (Sender <> nil) and (LpFilePath <> nil) then begin
      if RadioGroup1.ItemIndex = 0 then begin
        OpenDialog1.InitialDir := LpFilePath;
        OpenDialog1.Execute;
        Update;
      end else begin
        // ۂɂ͋NAvłGNXv[͋N
        // 邢́CNt@CɃpXw肷΋N
        LExeFile := 'explorer.exe';
        LhInst   := ShellExecute(Handle,
                                 'open',
                                 PChar(LExeFile),
                                 LpFilePath,
                                 nil,
                                 SW_SHOW);
        if LhInst <= 32 then begin
          MessageBox(Handle, 'NɎs܂D', '', MB_ICONINFORMATION);
        end;
      end;
    end;
  end;

  if LpFilePath    <> nil then CoTaskMemFree(LpFilePath);
  if LpDisplayName <> nil then CoTaskMemFree(LpDisplayName);
end;

//=============================================================================
//  ListBox1 ̍ڂICpX擾 Edit1 ɕ\
//=============================================================================
procedure TForm1.ListBox1Click(Sender: TObject);
begin
  ListBox1DblClick(nil);
end;

//=============================================================================
//  ListBox1  [Enter] L[C_uNbNƓ
//=============================================================================
procedure TForm1.ListBox1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_RETURN then begin
    ListBox1DblClick(Sender);
  end;
end;

//=============================================================================
//  RaditoGroup1  OnClick Cxg
//  ListBox1 ɃtH[JXړ [Enter] L[\ɂ
//=============================================================================
procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  ListBox1.SetFocus;
end;

end.
